//  This file is part of the computer game Kartofel.
//  Copyright (C) 2008 Pawel Aleksander Fedorynski <pfedor@fuw.edu.pl>
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef KARTOFEL_SAVED_GAME_H
#define KARTOFEL_SAVED_GAME_H

#include <vector>
#include <string>

#include "game.h"

namespace kartofel {

using std::vector;
using std::string;

class SavedGame {
public:
  SavedGame(int starting_level = 1);

  void Reset(int starting_level);
  void AddStep(const Input& input);

  bool Verify(const vector<Level>& levels,
              int* starting_level, int* end_level, int* score) const;
  void Encode(string* out) const;
  bool Decode(const string& encoded);

private:
  int starting_level_;
  vector<char> history_;
};

}  // namespace kartofel

#endif  // KARTOFEL_SAVED_GAME_H
