//  This file is part of the computer game Kartofel.
//  Copyright (C) 2008 Pawel Aleksander Fedorynski <pfedor@fuw.edu.pl>
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef KARTOFEL_UTIL_H
#define KARTOFEL_UTIL_H

#include <vector>
#include <iostream>
using namespace std;

namespace kartofel {

using std::vector;

enum {
  FULL_ANGLE = 360,
};

extern const double PI;

struct Point {
  int x;
  int y;
};

struct LineSegment {
  int x1;
  int y1;
  int x2;
  int y2;

  LineSegment(int xx1, int yy1, int xx2, int yy2)
    : x1(xx1), y1(yy1), x2(xx2), y2(yy2) { }
};

int DoubleToInt(double x);

// The parameters must be no greater than 10,000 (b/c of overflow.)
void FindIntersections(int x0, int y0, int x1, int y1,
                       int xc, int yc, int r,
                       vector<Point>* intersections);

bool LineSegmentsIntersect(const LineSegment& ls1,
                           const LineSegment& ls2,
                           int* intersection_x,
                           int* intersection_y);

}  // namespace kartofel

#endif  // KARTOFEL_UTIL_H
